
<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('客户编号')" prop="number">
        <el-input v-model="queryParams.number" :placeholder="$t('请输入客户编号')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('客户名称')" prop="name">
        <el-input v-model="queryParams.name" :placeholder="$t('请输入客户名称')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('客户等级')" prop="level">
        <el-select clearable  v-model="queryParams.level" :placeholder="$t('请选择客户等级')" clearable size="small">
          <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_LEVEL)"
                     :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('联系方式')">
        <el-input :placeholder="$t('请输入联系方式')" v-model="queryParams.defaultContactPhone"></el-input>
      </el-form-item>
      <el-form-item :label="$t('客户类别')" prop="level">
        <dict-selector :type="DICT_TYPE.CUSTOMER_TYPE"  multiple v-model="queryParams.type"></dict-selector>
      </el-form-item>
      <el-form-item :label="$t('客户经理')" prop="customerService">
        <el-select clearable  v-model="queryParams.customerService" :placeholder="$t('请选择客户经理')" clearable size="small">
          <el-option v-for="dict in customerServiceList"
                     :key="dict.id" :label="dict.nickname" :value="dict.id"/>
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('客户来源')" prop="source">
        <el-select clearable  v-model="queryParams.source" :placeholder="$t('请选择客户来源')" clearable size="small">
          <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_SOURCE)"
                     :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('国家')" prop="source">
        <el-select clearable  v-model="form.country" :placeholder="$t('请选择国家')">
          <el-option v-for="dict in countryList"
                     :key="dict.id" :label="dict.nameZh" :value="parseInt(dict.id)" />
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('客户状态')" prop="status">
        <el-select clearable  v-model="queryParams.status" :placeholder="$t('请选择客户状态')" clearable size="small">
          <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_STATUS)"
                     :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('创建时间')">
        <el-date-picker clearable  v-model="dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd"
                        type="daterange" range-separator="-" :start-placeholder="$t('开始日期')" :end-placeholder="$t('结束日期')" />
      </el-form-item>
      <el-form-item :label="$t('信用等级')" prop="department">
        <el-select clearable  v-model="form.level" >
          <el-option  v-for="(item,index) in creditList" :label="item.nameZh" :key="index" :value="item.id" ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{$t('搜索')}}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{$t('重置')}}</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:customer:create']">{{$t('新增')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:customer:export']">{{$t('导出')}}</el-button>
      </el-col>
       <el-col :span="1.5">
        <el-button type="primary" size="mini" @click="batchHandover"
                   :disabled="multipleSelection.length === 0"
                   >{{$t('批量移交')}}</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list"    @selection-change="handleSelectionChange">
      <el-table-column
        type="selection"
        width="55">
      </el-table-column>
      <el-table-column :label="$t('客户编号')" align="center" prop="number" />
      <el-table-column :label="$t('客户名称')" align="center" prop="name" />
      <el-table-column :label="$t('客户等级')" align="center" prop="vipLevelNameZh">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_LEVEL" :value="scope.row.level" />
        </template>
      </el-table-column>
      <el-table-column :label="$t('信用等级')" prop="creditLevelNameZh"></el-table-column>
      <el-table-column :label="$t('客户状态')" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_STATUS" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column :label="$t('主联系人')" prop="defaultContactName"></el-table-column>
      <el-table-column :label="$t('主联系方式')" prop="defaultContactPhone"></el-table-column>
      <el-table-column :label="$t('创建时间')" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('客户经理')" align="center" prop="customerService" :formatter="customerServiceFn">
      </el-table-column>
      <el-table-column :label="$t('国家')" align="center" prop="country" :formatter="countryFormatter"></el-table-column>
      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-folder-add" @click="distribution(scope.row)">{{$t('移交')}}</el-button>
          <el-button size="mini" type="text" icon="el-icon-crop" @click="fishingFn(scope.row)">{{$t('捞取')}}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!--   移交 -->
    <el-dialog
      center
      title="客服"
      :visible.sync="transferShow"
      width="30%">
      <div style="width: 100%;min-height: 200px;text-align: center">
       <el-select filterable v-model="service">
         <el-option v-for="(item,index) in customerServiceList" :key="index" :label="item.nickname" :value="item.id"></el-option>
       </el-select>
<!--        <el-radio-group v-model="service">-->
<!--          <el-radio style="margin: 5px;" v-for="(item,index) in customerServiceList" :key="index" :label="item.id">{{item.nickname}}</el-radio>-->
<!--        </el-radio-group>-->
      </div>
      <span slot="footer" class="dialog-footer">
    <el-button @click="transferShow = false">{{$t('取 消')}}</el-button>
    <el-button type="primary" v-if="isBatch" @click="transferFn(multipleSelection.map(item => item.id))">{{$t('确 定')}}</el-button>
    <el-button type="primary" v-else @click="transferFn([transferData.id])">{{$t('确 定')}}</el-button>
  </span>
    </el-dialog>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>
  </div>
</template>

<script>
import { createCustomer, updateCustomer, deleteCustomer,handOverCustomer,getPublicList,exportCustomerExcel, setFishing } from "@/api/ecw/customer";
import { getDictDatas, DICT_TYPE } from '@/utils/dict';
import upload from '@/components/ImageUpload'
import {listServiceUser} from "@/api/system/user";
import {getCountryListAll} from "@/api/ecw/country";
import {getCreditPage} from "@/api/customer/credit";
export default {
  name: "customerToBeAssigned",
  components: {
    upload
  },
  data() {
    return {
      getDictDatas,
      DICT_TYPE,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 客户列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      customerServiceList:[],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        number: null,
        name: null,
        level: null,
        source: null,
        customerService: null,
        status: null,
        department: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [{ required: true, message: this.$t('客户名称不能为空'), trigger: "blur" }],
        country: [{ required: true, message: this.$t('国家不能为空'), trigger: "blur" }],
        level: [{ required: true, message: this.$t('客户等级不能为空'), trigger: "blur" }],
        type: [{ required: true, message: this.$t('客户类别不能为空'), trigger: "blur" }],
        // createTime: [{ required: true, message: this.$t('创建时间不能为空'), trigger: "blur" }],
        source: [{ required: true, message: this.$t('客户来源不能为空'), trigger: "blur" }],
        customerService: [{ required: true, message: this.$t('客户经理不能为空'), trigger: "blur" }],
        status: [{ required: true, message: this.$t('客户状态不能为空'), trigger: "blur" }],
        founder: [{ required: true, message: this.$t('创建人不能为空'), trigger: "blur" }],
      },
      // 网点
      nodeList: [],
      showLine: false,
      service:undefined,//客服
      transferData:undefined,//移交数据
      transferShow:false,
      multipleSelection:[],
      isBatch:false,
      countryList:[],
      creditList:[]
    };
  },
  created() {
    this.getList();
    listServiceUser().then(r=>{
      console.log(r,'客服');
      this.customerServiceList = r.data;
    })
    getCountryListAll().then(r => {
      this.countryList = r.data
    })
    getCreditPage({page:1,rows:999}).then(r => {
      this.creditList = r.data.list
    })
    // getNodeList().then(r => {
    //   this.nodeList = r.data
    // })
  },
  methods: {
    countryFormatter(row, column, cellValue) {
      const country = this.countryList.find((e) => e.id === cellValue)
      return country?.nameZh
    },
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getPublicList(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        number: undefined,
        name: undefined,
        level: undefined,
        country: undefined,
        type: undefined,
        agentId: undefined,
        company: undefined,
        address: undefined,
        productType: undefined,
        productId: undefined,
        pickupPoint: undefined,
        memberId: undefined,
        birthday: undefined,
        balance: undefined,
        source: undefined,
        picture: undefined,
        customerService: undefined,
        customerContacts: [],
        customerLines: [],
        promoter: undefined,
        status: undefined,
        founder: undefined,
        department: undefined,
        invoiceTitle: undefined,
        licenseNumber: undefined,
        bank: undefined,
        bankNumber: undefined,
        project: undefined,
        billingAddress: undefined,
        billingTell: undefined,
        taxRate: undefined,
        remarks: undefined,
        arrivalConfirm: undefined,
        weightUnit: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$router.push('/customer/add-edit/0')
      // this.reset();
      // this.open = true;
      // this.title = "添加客户";
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.$router.push('/customer/query/' + row.id)
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.$router.push('/customer/edit/' + row.id)
      // this.reset();
      // const id = row.id;
      // getCustomer(id).then(response => {
      //   this.form = { ...this.form, ...response.data };
      //   this.open = true;
      //   this.title = "修改客户";
      // });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          // return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateCustomer(this.form).then(response => {
            this.$modal.msgSuccess(this.$t('修改成功'));
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createCustomer(this.form).then(response => {
          this.$modal.msgSuccess(this.$t('新增成功'));
          this.open = false;
          this.getList();
        });
      });
    },
    /** 移交按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm(this.$t('是否确认删除客户编号为"') + id + this.$t('"的数据项?')).then(function() {
        return deleteCustomer(id);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess(this.$t('删除成功'));
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm(this.$t('是否确认导出所有客户数据项?')).then(() => {
        this.exportLoading = true;
        return exportCustomerExcel(params);
      }).then(response => {
        this.$download.excel(response, `${this.$t('公海池客户')}.xls`);
        this.exportLoading = false;
      }).catch(() => {});
    },
    //分配客服
    distribution(row){
      this.service = row.customerService
      this.transferData = row;
      this.transferShow =true;
      this.isBatch = false;

    },
    customerServiceFn(val){
      if(this.customerServiceList.length > 0){
        let index =this.customerServiceList.findIndex(item => item.id === val.customerService);
        return index !== -1  ? this.customerServiceList[index]?.nickname :''
      }else {
        return ''
      }
    },
    transferFn(val){
      if(!this.service){
        return this.$message.warning(this.$t('请选择客户经理！'));
      }
      handOverCustomer({
        customerServiceId:this.service,
        customerIdList:val
      }).then(r=>{
        if(r.code === 0){
          this.transferShow = false;
          this.service = '';
          this.getList();
          this.multipleSelection = [];
          this.$message.success(this.$t('移交成功！'));
        }
      })
    },
    fishingFn(row){
      this.$confirm(`${this.$t('是否要捞取')}${row.name}${this.$t('的客户')}`, this.$t('提示'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: 'warning'
      }).then(() => {
        setFishing({id:row.id}).then(r=>{
          if(r.code === 0){
            this.getList()
            this.$message({
              type: 'success',
              message: this.$t('捞取成功!')
            });
          }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: this.$t('已取消捞取')
        });
      });
    },
    batchHandover(){
      this.transferShow = true;
      this.isBatch = true
    },
    handleSelectionChange(val){
      this.multipleSelection = val;
    }
  }
};
</script>
